
/*
 * ホスト名、名称で指定されたクッキーの配列を返します。
 * 
 * @param host
 * @param name
 * @return クッキーの配列
 */
function getCookie(host, name) {
	var cookieArray = new Array();
	var ret = getCookieByHost(host);

	for(var i = 0; i < ret.length; i++) {
		if(ret[i].name == name) {
			cookieArray.push(ret[i]);
		}
	}
	
	return cookieArray;
}

/*
 * ホスト名で指定されたクッキーの配列を返します。
 * 
 * @param host
 * @return クッキーの配列
 */
function getCookieByHost(host) {
	var cookieArray = new Array();
	
	var cm = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager);
	var it = cm.enumerator;

	while(it.hasMoreElements()) {
		var cookie = it.getNext();
		
		if(cookie instanceof Components.interfaces.nsICookie
			&& cookie.host == host) {
			
			cookieArray.push(cookie);
		}
	}
	
	return cookieArray;
}