//const
const BOUNDARY = "moonfoxBoundaryAAzvfj";
const FEED = "\r\n";


/**
 * 新月ネットワークからCSVデータを取得します。。
 *
 * @param host
 * @param port
 * @param method
 * @param threadPath
 * @param func データ取得に成功した場合に呼び出す関数
 * @param errfunc 失敗した場合に呼び出す関数。
 */
function getThreadData(threadPath, func, errfunc) {
	var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
	
	var reqstr = getSakuRootUrl() + "/thread.cgi/" + threadPath;
	
	request.onreadystatechange = function() {receiveThreadData(request, func);}
	request.onerror = errfunc;
	request.open("GET", reqstr, true);
	request.send(null);
}

/**
 * 
 * @param {Object} name
 * @param {Object} data
 */
function makePart(name, data) {
	var postData = "--" + BOUNDARY + FEED
					+ "Content-Disposition: form-data; name=\"" + name + "\"" + FEED
					+ FEED
					+ data + FEED;
	
	return postData;
}

function makeAttachPart(file) {
	var is = file.establishInputStream();
	var sis = Components.classes["@mozilla.org/scriptableinputstream;1"]
    							.createInstance(Components.interfaces.nsIScriptableInputStream);
  	sis.init(is);
	var readStr = "";
	var ch = sis.read(4096);
	while(ch) {
		readStr += ch;
		ch = sis.read(4096);
	}
	sis.close();
	is.close();
	//var bis = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
	//bis.setInputStream(is);
	
	//var str = new Array(bis.available());
	//str = toHexStr(bis.readBytes(bis.available()));
	//document.getElementById("text_body").value = str.toString();
	
	var postData = "--" + BOUNDARY + FEED
					+ "Content-Disposition: form-data; name=\"attach\"; filename=\"" + file.getName() + "\"" + FEED
					+ "Content-Type: text/plain" + FEED
					+ FEED
					+ readStr + FEED;
	
	return postData;
}

/**
 * 
 * @param {Object} host
 * @param {Object} port
 * @param {Object} articleData
 * @param {Object} func
 * @param {Object} errfunc
 */
function postArticle(articleData, func, errfunc) {
	//var postData = "POST /cgi-bin/multi.cgi HTTP/1.0\r\n";
	//postData += "Content-Type: multipart/form-data; boundary=" + BOUNDARY + FEED + FEED;
	var postData = makePart("cmd", "post");
	postData += makePart("dopost", articleData.dopost);
	postData += makePart("file", articleData.file);
	postData += makePart("error", articleData.error);
	postData += makePart("name", articleData.name);
	postData += makePart("mail", articleData.mail);
	postData += makePart("passwd", articleData.passwd);
	postData += makePart("body", articleData.body);
	postData += makePart("suffix", articleData.suffix);
	
	if(articleData.attach) {
		postData += makeAttachPart(articleData.attach);
	}
	//return;
	postData += "--" + BOUNDARY;
	document.getElementById("text_body").value = postData;
	
	var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
	var reqstr = "http://snow-cat.hp.infoseek.co.jp/cgi-bin/multi.cgi";
	
	request.onreadystatechange = function() { testrec(request); }
	request.onerror = errfunc;
	request.open("POST", reqstr, true);
	request.setRequestHeader("Content-Type", "multipart/form-data; boundary=" + BOUNDARY);
	request.setRequestHeader("Connection", "close");
	//request.setRequestHeader("Content-length", postData.length);
	request.send(postData);
}

/**
 * リクエストのステータスが変化した場合呼び出されます。
 *
 * @param request
 * @param func データ取得に成功した場合に呼び出す関数
 * @param errfunc 失敗した場合に呼び出す関数。
 * @param public_gateway_mode 公開ゲートウェイモード
 */
function receiveThreadData(request, func) {
	if (request.readyState == 4) {
		if (request.status == 200) {
			func(request);
		}
	}
}


//-------------------------------------------


function getPageContent(postData)
{
  var listener = {
    finished : function(data){
      document.getElementById("text_body").value = data;
    }
  }

  readAllFromSocket("snow-cat.hp.infoseek.co.jp",80, "GET / HTTP/1.0\r\n\r\n",listener);
}

function readAllFromSocket(host,port,outputData,listener)
{
  try {
    var transportService =
      Components.classes["@mozilla.org/network/socket-transport-service;1"]
        .getService(Components.interfaces.nsISocketTransportService);
    var transport = transportService.createTransport(null,0,host,port,null);

    var outstream = transport.openOutputStream(0,0,0);
    outstream.write(outputData,outputData.length);

    var stream = transport.openInputStream(0,0,0);
    var instream = Components.classes["@mozilla.org/scriptableinputstream;1"]
      .createInstance(Components.interfaces.nsIScriptableInputStream);
    instream.init(stream);

    var dataListener = {
      data : "",
      onStartRequest: function(request, context){},
      onStopRequest: function(request, context, status){
        instream.close();
        outstream.close();
        listener.finished(this.data);
      },
      onDataAvailable: function(request, context, inputStream, offset, count){
        this.data += instream.read(count);
      },
    };

    var pump = Components.
      classes["@mozilla.org/network/input-stream-pump;1"].
        createInstance(Components.interfaces.nsIInputStreamPump);
    pump.init(stream, -1, -1, 0, 0, false);
    pump.asyncRead(dataListener,null);
  } catch (ex){
    return ex;
  }
  return null;
}



