//定数
const PANE_PADDING = 25;
const THUMB_SPACE = 20;

//変数
var threadFileList = null;
var thumbList = new Array();
var thumbSize = 150;
var imgNumPerPage = 20;
var checkTimer = null;
var savedPaneWidth = 0;
var savedYOffset = -1;

/**
 * 
 */
function check() {
	
	var paneWidth = window.innerWidth;
	var yOffset = window.pageYOffset;
	
	var sizeChanged = (paneWidth != savedPaneWidth);
	var yOffsetChanged = (yOffset != savedYOffset);
	
	//
	if(sizeChanged) {
		configThumbPosition();
		savedPaneWidth = paneWidth;
	}
	
	//
	if(sizeChanged || yOffsetChanged) {
		var visiThumbList = getVisibleThumbList();
		
		for(var i = 0; i < visiThumbList.length; i++) {
			visiThumbList[i].load();
		}
		
		savedYOffset = yOffset;
	}
}

/**
 * 
 */
function clearCache() {
	var classID = Components.classes["@mozilla.org/network/cache-service;1"];
	var cacheService = classID.getService(Components.interfaces.nsICacheService);
	cacheService.evictEntries(Components.interfaces.nsICache.STORE_ANYWHERE);
}

/**
 * 
 */
function configThumbPosition() {
	var paneWidth = window.innerWidth;
	
	var colNum = (paneWidth - PANE_PADDING * 2 + THUMB_SPACE) / (thumbSize + THUMB_SPACE);
	colNum = parseInt(colNum);
	
	if(colNum == 0)
		colNum = 1;
	
	var rowCnt = 0;
	
	for(var i = 0; i < thumbList.length; i += colNum) {
		
		for(var colCnt = 0; colCnt < colNum; colCnt++) {
			var left = PANE_PADDING + ((thumbSize + THUMB_SPACE) * colCnt);
			var top = PANE_PADDING + ((thumbSize + THUMB_SPACE) * rowCnt);
			
			if(thumbList[i + colCnt]) {
				thumbList[i + colCnt].setX( parseInt(left) );
				thumbList[i + colCnt].setY( parseInt(top) );
			}
		}
		
		rowCnt += 1;
	}
}

/**
 * 
 */
function constructThumbnail(cacheFile, page, maxNum) {
	var pane = document.getElementById("stack_pane");
	
	var fileList = getThumbFileList(cacheFile, page, maxNum);
	
	for(var i = 0; i < fileList.length; i++) {
		var thumb = new Thumbnail(fileList[i].getUrlSpec(), thumbSize);
		thumb.setSize(thumbSize);
		//thumb.load();
		thumbList.push(thumb);
	}
	
	configThumbPosition();
}

/**
 * 
 */
function endup() {
	
	checkTimer.cancel();
	
	clearCache();
}

/**
 * 
 */
function getVisibleThumbList() {
	var list = [];
	var yOffset = self.pageYOffset;
	var yEnd = yOffset + self.innerHeight;
	
	for(var i = 0; i < thumbList.length; i++) {
		var yTop = thumbList[i].getY();
		var yBottom = parseInt(yTop) + parseInt(thumbSize);
		
		if( (yTop >= yOffset && yTop <= yEnd)
				|| (yBottom >= yOffset && yBottom <= yEnd) ) {
			list.push(thumbList[i]);
		}
	}
	
	return list;
}

/**
 * 
 */
function setThumbSize(size) {
	thumbSize = parseInt(size);
	
	configThumbPosition();
	
	for(var i = 0; i < thumbList.length; i++) {
		thumbList[i].setSize(thumbSize);
		thumbList[i].repaint();
	}
	
	var visiThumbList = getVisibleThumbList();
		
	for(var i = 0; i < visiThumbList.length; i++) {
		visiThumbList[i].load();
	}
}

/**
 * 
 */
function startup() {
	try {
		var milsec = 500;
		
		checkTimer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		var callback = {
			notify: function(timer) {
				check();
			}
		}
		checkTimer.initWithCallback(
						callback
						, milsec
						, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
						
	} catch(e) {
		alert(e);
	}
}
