//定数
const PANE_PADDING = 25;
const THUMB_SPACE = 20;
const SUCCESS = 1;
const ERROR = -1;


//変数
var startFlg = false;
var exitFlg = true;
var loadedImageAndShow = false;
var currentPage = 1;
var maxThumbNumPerPage = 50;
var onceLoadImageNum = 0;
var orgSizeList = new Array();
var threadFileList = null;
var paneboxSize = null;
var selectedThread = null;
var imageTracker = null;

var console = Components.classes["@mozilla.org/consoleservice;1"]
                                 .getService(Components.interfaces.nsIConsoleService);

/*
 * サムネイルのサイズを計算します。
 *
 * @param img
 */
function calcSize(img) {
	var orgWidth = orgSizeList[img.getAttribute("id")].width;
	var orgHeight = orgSizeList[img.getAttribute("id")].height;
	
	var size = {width:0,height:0};
	var thumbSize = getThumbSize();
	
	if(orgWidth > orgHeight) {
		size.width = thumbSize;
		size.height = parseInt(thumbSize * (orgHeight / orgWidth));
	} else if(orgWidth < orgHeight) {
		size.height = thumbSize;
		size.width = parseInt(thumbSize * (orgWidth / orgHeight));
	} else {
		size.width = thumbSize;
		size.height = thumbSize;
	}
	
	return size;
}

/*
 * パネルサイズをチェックし収まりきらない時は位置を調整します。
 */
function checkSize() {
	var panebox = document.getElementById("box_right");
	
	if(paneboxSize != panebox.boxObject.width) {
		paneboxSize = panebox.boxObject.width;
		configThumbPosition();
	}
}

function clearCache() {
	var classID = Components.classes["@mozilla.org/network/cache-service;1"];
	var cacheService = classID.getService(Components.interfaces.nsICacheService);
	//cacheService.evictEntries(Components.interfaces.nsICache.STORE_ON_DISK);
	cacheService.evictEntries(Components.interfaces.nsICache.STORE_IN_MEMORY);
	//cacheService.evictEntries(Components.interfaces.nsICache.STORE_ANYWHERE);
}

/*
 * サムネイルのポジションを調節します。
 */
function configThumbPosition() {
	if(!selectedThread || !selectedThread.exist())
		return;
	
	if(!loadedImageAndShow && !imageTracker.isCompleted())
		return;
	
	var thumbSize = getThumbSize();
	var pane = document.getElementById("stack_pane");
	var rightBox = document.getElementById("box_right");
	var paneWidth = rightBox.boxObject.width;
	
	var colNum = (paneWidth - PANE_PADDING * 2 + THUMB_SPACE) / (thumbSize + THUMB_SPACE);
	colNum = parseInt(colNum);
	
	if(colNum == 0)
		colNum = 1;
	
	var imgNodes = pane.getElementsByTagName("image");//childNodes;
	var rowCnt = 0;
	
	for(var i = 0; i < imgNodes.length; i += colNum) {
		for(var colCnt = 0; colCnt < colNum; colCnt++) {
			if(!imgNodes[i + colCnt]
				|| !imageTracker.checkLoaded(imgNodes[i + colCnt])) {
				continue;
			}
			
			//変更が反映されないことへの対応
			if(imgNodes.length == 1 && i + colCnt == 0) {
				imgNodes[i + colCnt].setAttribute("left", 0);
			}
			
			if(imgNodes[i + colCnt]) {
				var size = calcSize(imgNodes[i + colCnt]);
				
				var left = PANE_PADDING + ((thumbSize + THUMB_SPACE) * colCnt) + parseInt((thumbSize - size.width) / 2);
				var top = PANE_PADDING + ((thumbSize + THUMB_SPACE) * rowCnt) + parseInt((thumbSize - size.height) / 2);
				
				imgNodes[i + colCnt].setAttribute("left", left);
				imgNodes[i + colCnt].setAttribute("top", top);
				imgNodes[i + colCnt].setAttribute("width", size.width);
				imgNodes[i + colCnt].setAttribute("height", size.height);
				
				imgNodes[i + colCnt].style.visibility = "visible";
			} else {
				break;
			}
		}
		
		rowCnt += 1;
	}
}

/*
 * ページコンボを構築します。
 */
function constructPageCombo() {
	var cbo = document.getElementById("menulist_page");
	var pagelabel = document.getElementById("label_pagenum");
	var imglabel = document.getElementById("label_imgnum");
	
	var imgnum = getThumbFileList(selectedThread).length;
	var pageNum = parseInt(imgnum / maxThumbNumPerPage) + 1;
	pagelabel.setAttribute("value", "/" + pageNum);
	imglabel.setAttribute("value", imgnum);
	
	for(var i = 1; i <= pageNum; i++) {
		cbo.appendItem(i, i, "");
	}
	
	cbo.value = currentPage;
}

/*
 * スレッドのポップアップメニューを構築します。
 */
function constructThreadPopup() {
	var popup = document.getElementById("popup_thread");
	
	var cacheList = getThreadCacheFileList();
	
	for(var i = 0; i < cacheList.length; i++) {
		var imgFileList = cacheList[i].getAttachFileList(EXT_LIST);
		
		if(!imgFileList ||  imgFileList.length <= 0) {
			continue;
		}
		
		var item = document.createElement("menuitem");
		
		item.setAttribute("label", cacheList[i].getTitle() );
		item.setAttribute("value", cacheList[i].getDirName() );
		
		item.onclick = new Function("threadMenuItemClicked(this);");
		
		popup.appendChild(item);
	}
}

/*
 *
 */
function constructThreadList() {
	var list = document.getElementById("list_thread");
	
	for(var i = 0; i < threadFileList.length; i++) {
		var item = document.createElement("listitem");
		
		item.setAttribute("label", decodeTitle(threadFileList[i].getName()) );
		item.setAttribute("value", threadFileList[i].getName());
		
		list.appendChild(item);
	}
}

/*
 * サムネイルを構築します。
 */
function constructThumbnail() {
	if(!selectedThread || !selectedThread.exist())
		return;
	
	var pane = document.getElementById("stack_pane");
	var thumbSize = getThumbSize();
	
	fileList =  getThumbFileList(selectedThread, currentPage, maxThumbNumPerPage);
	var label = document.getElementById("text_title");
	label.setAttribute("value", selectedThread.getTitle() );
	
	imageTracker = new ImageTracker();
	imageTracker.setThumbFileList(fileList);
	
	var num = onceLoadImageNum;
	
	if(!num || num == 0)
		num = fileList.length;
	
	for(var i = 0; i < num; i++) {
		loadImage(fileList[i]);
	}
	
	/*
	restOfLoadingImage = fileList.length;
	
	for(var i = 0; i < fileList.length; i++) {
		var file = fileList[i];
		var ext = file.getExt();
		
		var img = document.createElement("image");
		img.setAttribute("id", file.getName());
		img.setAttribute("class", "thumbnail");
		img.style.visibility = "hidden";
		//img.setAttribute("validate", "never");
		img.setAttribute("src", file.getUrlSpec());
		img.left = 0;
		img.onload = function() {
			notifyCompleteLoading(img, file, SUCCESS);
		}
		img.onerror = function() {
			notifyCompleteLoading(img, file, ERROR);
		}
		img.onclick = function() {
			//alert("Σ(ﾟДﾟ; )！ ");
			showImageWindow(fileList, i);
		}
		
		pane.appendChild(img);
	}*/
}

/*
 * nameで示されるスレッドの添付ファイルを格納したディレクトリのファイルオブジェクトを返します。
 *
 * @param name
 * @return
 *
function getAttachFile(name) {
	var attachDir = null;
	
	var thDir = getThreadFile(name);
	
	if(thDir) {
		attachDir = new File(thDir, "attach");
	}
	
	return attachDir;
}*/


/*
 * サムネイルの対象となるファイルを配列にして返します。
 *
 * @param page
 * @return
 *
function getThumbFileList(page) {
	var fileList = new Array();
	var selAttachDir = getAttachFile(selectedThreadName);
	
	if(selAttachDir && selAttachDir.exist()) {
		var candidates = selAttachDir.listFile();
		var start = 0;
		var end = candidates.length - 1;
		
		if(page) {
			start = maxThumbNumPerPage * (page - 1);
			end = start + maxThumbNumPerPage - 1;
		}
		
		for(var i = start; i <= end; i++) {
			if(!candidates[i])
				break;
			
			var ext = candidates[i].getExt();
			
			if(contain(EXT_LIST, ext)) {
				fileList.push(candidates[i]);
			}
		}
	}
	
	return fileList;
}*/

/*
 * スクロールバーの現在値からサムネイルサイズを返します。
 *
 * @return
 */
function getThumbSize() {
	var bar = document.getElementById("scrollbar_thumbsize");
	var size = bar.getAttribute("curpos");
	
	return parseInt(size);
}

/*
 * スレッドが画像の添付ファイルを含む場合trueを返します。
 *
 * @param dir
 * @return
 *
function hasImageFile(dir) {
	var attachDir = new File(dir, "attach");
	var fileList = attachDir.listFile();
	var found = false;
	
	for(var i = 0; i < fileList.length; i++)  {
		var ext = fileList[i].getExt();console.logStringMessage(ext);
		if(contain(EXT_LIST, ext)) {
			found = true;
			break;
		}
	}
	
	return found;
}*/

/*
 * fileで指定された画像を読み込みます。
 *
 * @param file
 */
function loadImage(file) {
	if(!file)
		return;
	
	imageTracker.notifyStartLoading(file);
	
	var pane = document.getElementById("stack_pane");
	
	var img = document.createElement("image");
	pane.appendChild(img);
	
	img.setAttribute("id", file.getName());
	img.setAttribute("class", "thumbnail");
	img.style.visibility = "hidden";
	//img.setAttribute("validate", "never");
	img.setAttribute("src", file.getUrlSpec());
	img.left = 0;
	img.onload = function() {
		notifyCompleteLoading(img, file, SUCCESS);
	}
	img.onerror = function() {
		notifyCompleteLoading(img, file, ERROR);
	}
	img.onclick = function() {
		showImageWindow(file);
	}
}

/*
 * 個々のイメージが読み込まれた時に呼び出されます。
 *
 * @param img
 * @param file
 * @param status
 */
function notifyCompleteLoading(img, file, status) {
	var orgSize = {width:150,height:150};
	
	if(status == ERROR) {
		img.setAttribute("tooltiptext", "Unsupported image. " + img.getAttribute("src"));
		img.setAttribute("src", "");
		img.setAttribute("class", "error-icon");
	} else {
		//イメージのオリジナルサイズを保存
		orgSize.width = img.boxObject.width;
		orgSize.height = img.boxObject.height;
	}
	
	orgSizeList[img.getAttribute("id")] = orgSize;
	
	//イメージの読込が終了したことを通知
	imageTracker.notifyCompleteLoading(img);
	
	if(loadedImageAndShow)
		configThumbPosition();
	
	var infoLabel = document.getElementById("label_info");
	infoLabel.setAttribute("value", "Loading images : " + imageTracker.getStatus() + "%");
	
	if(imageTracker.isCompleted()) {
		infoLabel.setAttribute("hidden", true);
		configThumbPosition();
	} else {
		var next = imageTracker.getNextImageFile();
		loadImage(next);
	}
}

/*
 * 現在選択されているスレッドのディレクトリを表示します。
 */
function openDirectory() {
	
	if(selectedThread && selectedThread.exist()) {
		selectedThread.getAttachDir().reveal();
	}
}

/**
 * 
 * @param {Object} file
 */
function showImageWindow(file) {
	
	setPref("moonfox.imgviewer.selected_image", file.getUrlSpec());
	
	var winObj = window.open("chrome://moonfox/content/imgviewer/image.xul"
					, "moonfox_image"
					, "resizable=yes,status=no,toolbar=no");
	
}