/*
 * メニューアイテムをマウスが通過する時。
 *
 * @param item
 */
function browserMenuItemMouseExited(item) {
	item.className = "browser_menu_item";
}

/*
 * メニューアイテムをマウスが離れる時。
 *
 * @param item
 */
function browserMenuItemMouseOvered(item) {
	item.className = "browser_menu_item_onmouse";
}


/*
 * メニューを閉じます。
 *
 * @param event
 */
function closeBrowserMenu(event) {
	var content = document.getElementById("div_browser_menu_content");
	content.setAttribute("hidden", true);
	
	var menu = document.getElementById("browser_menu");
	menu.style.backgroundImage = 'url("chrome://moonfox/skin/menubg.png")';
}

/*
 * スレッドタイトルを閉じます。
 */
function closeThreadTitle(event) {
	var title = document.getElementById("thread_title");
	title.setAttribute("hidden", true);
}

/*
 * 初期化
 */
function initBrowserMenu() {
	var br = document.getElementById("browser_viewer");
	var menu = document.getElementById("browser_menu");
	menu.style.top = String(br.boxObject.y + 5) + "px";
	menu.style.right = "25px";
	
	var title = document.getElementById("box_thread_title");
	title.style.top = String(br.boxObject.y) + "px";
	title.style.left = "0px";
}

/*
 * メニューを開きます。
 *
 * @param event
 */
function openBrowserMenu(event) {
	var content = document.getElementById("div_browser_menu_content");
	content.setAttribute("hidden", false);
	
	var menu = document.getElementById("browser_menu");
	menu.style.backgroundImage = 'url("chrome://moonfox/skin/menubg_onmouse.png")';
}

/*
 * スレッドタイトルを開きます。
 */
function openThreadTitle(event) {
	var title = document.getElementById("thread_title");
	title.setAttribute("hidden", false);
}


/*
 * メニューを消去します。
 */
function remeoveBrowserMenu() {
	document.getElementById("browser_menu").setAttribute("hidden", true);
	document.getElementById("box_thread_title").setAttribute("hidden", true);
}

/*
 * メニューを表示します。
 */
function showBrowserMenu() {
	document.getElementById("browser_menu").setAttribute("hidden", false);
	document.getElementById("box_thread_title").setAttribute("hidden", false);
}

/*
 * 表示するスレッドのタイトルを設定します。
 *
 * @param title
 */
function setShowingThreadTitle(title) {
	var obj = document.getElementById("thread_title");
	obj.setAttribute("value", title);
}