/**
 * 
 */
function deleteRecord() {
	var idList = getSelectedRecordList();
	
	if(!idList || idList.length == 0) {
		alert( msg("W_02") );
		return;
	}
	
	//削除実行ボタン押下不可にする
	document.getElementById("button_exec_deletion").disabled = true;
	
	var userData = {idList:null,file:"",dopost:null,name:"",passwd:"",body:""};
	userData.idList = idList;
	userData.file = cacheFile.file.getName();
	
	if(document.getElementById("check_dopost").checked)
		userData.dopost = "dopost"; 
	userData.name = encodeURIComponent(document.getElementById("text_name").value);
	userData.passwd = encodeURIComponent(document.getElementById("text_passwd").value);
	userData.body = encodeURIComponent(document.getElementById("text_body").value);
	
	var postData = "cmd=rdel&file=" + cacheFile.file.getName() + "&";
	
	for(var i = 0; i < idList.length; i++) {
		postData += "record=" + idList[i];
		
		if(i != idList.length - 1)
			postData += "&";
	}
	
	postDataToAdmin(deleteRecordCallback, deleteRecordError, postData, userData);
}

/**
 * Callback
 * @param {Object} request
 * @param {Object} userData
 */
function deleteRecordCallback(request, userData) {
	try {
		var resTxt = request.responseText;
		
		if( resTxt.match(/name=\"sid\" value=\"([\w]+)\" \/>/) ) {
			var sid = RegExp.$1;
			var postData = "cmd=xrdel&file=" + userData.file + "&sid=" + sid + "&";
			if(userData.idList.length == 1 && userData.dopost) {
				postData += "dopost=dopost&"
							+ "name=" + userData.name + "&"
							+ "passwd=" + userData.passwd + "&"
							+ "body=" + userData.body + "&";
				
			}
			
			for(var i = 0; i < userData.idList.length; i++) {
				postData += "record=" + userData.idList[i];
				
				if(i != userData.idList.length - 1)
					postData += "&";
			}
			
			
			postDataToAdmin(finishRecordDeletion, deleteRecordError, postData, userData);
		}
	} catch(e) {
		alert(e);
	}
}

/**
 * 
 * @param {Object} request
 * @param {Object} userData
 */
function deleteRecordError(request, userData) {
	alert(msg("E_02"));
}

/**
 * 
 * @param {Object} request
 * @param {Object} userData
 */
function finishRecordDeletion(request, userData) {
	try{
		var idList = userData.idList;
		
		for(var i = 0; i < idList.length; i++) {
			var record = showingRecordDB[idList[i]];
			
			record.doDeletion();
		}
		
		//Update
		mfLog.updateLog(showingRecordList, showingFile);
		
		//
		document.getElementById("div_deleteform").style.display = "none";
		showPastLog();
	} catch(e) {
		alert(e);
	}
}

/**
 * 
 */
function prepareForRecordDeletion() {
	document.getElementById("div_deleteform").style.display = "block";
	var cnt = showCheckedRecordOnly();
	
	var dopost = document.getElementById("check_dopost");
	var name = document.getElementById("text_name");
	var passwd = document.getElementById("text_passwd");
	var body = document.getElementById("text_body");
	var execBtn = document.getElementById("button_exec_deletion");
	
	if(cnt == 0) {
		execBtn.disabled = true;
	} else if(cnt == 1) {
		execBtn.disabled = false;
		dopost.disabled = false;
		name.disabled = false;
		passwd.disabled = false;
		body.disabled = false;
	} else {
		execBtn.disabled = false;
		dopost.disabled = true;
		name.disabled = true;
		passwd.disabled = true;
		body.disabled = true;
	}
}