/**
 * 
 */
function appendAnchor(body) {
	var newBody = "";
	var index;
	
	while( (index = body.search(/(http:\/\/[^\b\r\n\f\t\v\s<>\"\']+)/)) != -1
				|| (index = body.search(/(ttp:\/\/[^\b\r\n\f\t\v\s<>\"\']+)/)) != -1 ) {
		newBody += body.substring(0, index);
		var url = RegExp.$1;
		var isImg = url.match(/\.jpg$|\.jpeg$|\.gif$|\.png$|\.bmp$/);
		
		newBody += "<a " + "href='" + url + "' ";
		
		if(isImg) {
			newBody += "onmouseover=\"showImageBox(event, '" + url + "');\" "; 
			newBody += "onmouseout=\"closeImageBox(event);\" ";
		}
					
		newBody += ">" + url + "</a>";
		body = RegExp.rightContext;
	}
	
	newBody += body;
	
	return newBody;
}

/**
 * ブラケットリンクを追加
 */
function appendBracketLink(body) {
	var newBody = "";
	var index;
	
	//ブラケットリンク
	while( (index = body.search(/\[\[([^\[\]]+)\]\]/)) != -1 ) {
		newBody += body.substring(0, index);
		var str = RegExp.$1;
		var app = null;
		var thTitle = null;
		var blockId = null;
		var arr = str.split("/");
		
		if(arr.length == 1) {
			thTitle = arr[0];
		} else if(arr.length == 2) {
			thTitle = arr[0];
			blockId = arr[1];
		} else {
			app = arr[0];
			thTitle = arr[1];
			blockId = arr[2];
		}
		
		if( (!app || app == "thread")
				&& thTitle != "") {
			var thName = encodeTitle(thTitle);
			
			newBody += "[[<a " + "href='chrome://moonfox/content/thread/thread.html?fn=" + thName + "' ";
			
			if(blockId)
				newBody += "onmouseover='bracketLinkMouseOvered(event, \""
							+ thName + "\",\""
							+ blockId + "\");' ";
			
			newBody += ">" + str + "</a>]]";
		} else {
			newBody += "[[" + str + "]]";
		}
		
		body = RegExp.rightContext;
		
	}
	
	newBody += body;
	
	return newBody;
}


/**
 * 
 * @param {Object} body
 */
function appendReferenceToRecord(body) {
	var newBody = "";
	var index;
	
	//レス参照
	while( (index = body.search(/(&gt;&gt;[\w]{8})/)) != -1 ) {
		newBody += body.substring(0, index);
		var ref = RegExp.$1;
		var blockId = ref.substring(8);
		newBody += "<a "
					+ "href='#" + blockId + "' "
					+ "onmouseover=\"refAnchorMouseOvered(event, '" + blockId + "');\">"
					+ ref + "</a>";
		body = RegExp.rightContext;
	}
	
	newBody += body;
	
	return newBody;
}

/**
 * 
 * @param {Object} body
 */
function editBody(body) {
	if(!body)
		return body;
	
	body = appendReferenceToRecord(body);
	
	body = appendAnchor(body);
	
	body = appendBracketLink(body);
	
	return body;
}


/**
 * レスのエレメントを生成します。
 * @param {Object} record
 * @param forRef
 */
function makeRecordElement(record, forRef) {
	var blockId = record.hash.substring(0, 8);
	
	var dl = document.createElement("dl");
	if(!forRef)
		dl.id = record.id;
	
	var dt = document.createElement("dt");
	dl.appendChild(dt);
	
	
	//Checkbox
	if(!forRef) {
		var chk = document.createElement("input");
		dt.appendChild(chk);
		chk.id = "check_" + record.id;
		chk.className = "std";
		chk.type = "checkbox";
		
		chk.onclick = function() {
			checkboxClicked(dl, chk);
		}
	}
	
	//No, ID
	var no = document.createElement("span");
	var id_head = document.createElement("span");
	var id = document.createElement("span");
	dt.appendChild(no);
	dt.appendChild(id_head);
	dt.appendChild(id);
	id_head.className = "header";
	no.innerHTML = record.no;
	no.onclick = function() {
		blockIdClicked(blockId);
	}
	
	id_head.innerHTML = "&nbsp;ID:";
	id.innerHTML = blockId;
	id.onclick = function() {
		blockIdClicked(blockId);
	}
	
	
	//Name
	var name = document.createElement("span");
	dt.appendChild(name);
	name.className = "name";
	name.innerHTML = "&nbsp;" + record.name;
	
	//Date
	var date = document.createElement("span");
	dt.appendChild(date);
	date.className = "date";
	var dateObj = new Date();
	dateObj.setTime(record.stamp * 1000);
	date.innerHTML = "&nbsp;&nbsp;" + dateObj.toLocaleString();
	
	//Attach
	if(record.isAttached()) {
		var file = record.getAttachFile();
		
		if(file && file.exist()) {
			var attach = document.createElement("span");
			dt.appendChild(attach);
			
			var url = file.getUrlSpec();
			var ext = file.getExt();
			var showNm = file.getName().match(/^[0-9]+/);
			if(ext && ext != "")
				showNm += "." + ext;
			var str = "&nbsp;<a href='" + url + "' ";
			
			if(ext == "jpg" || ext == "jpeg" || ext == "png" || ext == "gif" || ext == "bmp") {
				str += "onmouseover=\"showImageBox(event, '" + url + "');\" "
						+ "onmouseout=\"closeImageBox(event);\" "
			}
			
			str += ">" + showNm + "</a>";
			attach.innerHTML = str;
		}
	}
	
	//Mail
	if(record.mail) {
		var mail_head = document.createElement("span");
		var mail = document.createElement("span");
		dt.appendChild(mail_head);
		dt.appendChild(mail);
		mail_head.className = "header";
		mail.className = "mail";
		mail_head.innerHTML = "&nbsp;&nbsp;E-mail: ";
		mail.innerHTML = record.mail;
	}
	
	
	//Sign
	if(record.pubkey) {
		var pubkey_head = document.createElement("span");
		var pubkey = document.createElement("span");
		dt.appendChild(pubkey_head);
		dt.appendChild(pubkey);
		pubkey_head.className = "header";
		pubkey.className = "pubkey";
		pubkey_head.innerHTML = "&nbsp;&nbsp;Sign:";
		
		var cryptor = new CryptoHash();
		cryptor.init(cryptor.MD5);
		cryptor.calcStr(record.pubkey, "UTF-8", true);
		var ret = cryptor.getMessage();
		pubkey.innerHTML = ret.substring(0, 11);
	}
	
	if(record.unread) {
		no.className = "unread";
		id.className = "unread";
	} else {
		no.className = "read";
		id.className = "read";
	}
	
	//本体
	var dd = document.createElement("dd");
	dd.className = "body";
	dd.innerHTML = editBody(record.body);
	
	//削除通知がある場合
	if(record.isRemovalNotification()) {
		var removeId = record.removeStamp + "_" + record.removeHash;
		var removeBlockId = record.removeHash.substring(0,8);
		
		dd.innerHTML += "<br>削除通知："
						+ "[[<a href=\"#" + removeId + "\">"
						+ removeBlockId 
						+ "</a>]]";
	}
	
	dl.appendChild(dd);
	
	return dl;
}